# $Revision: 1.32 $, $Date: 2012/01/05 13:45:43 $
# TODO
# - readline not working in d8 (at least arrows)
Summary:	JavaScript Engine by Google
Summary(pl.UTF-8):	Silnik JavaScript firmy Google
Name:		v8
Version:	3.6.6.15
Release:	1
License:	BSD
Group:		Applications
Source0:	http://commondatastorage.googleapis.com/chromium-browser-official/%{name}-%{version}.tar.bz2
# Source0-md5:	32c22a2840a4e0e580a9e75aa3930fbd
Patch0:		%{name}-cstdio.patch
Patch1:		%{name}-strndup.patch
Patch2:		%{name}-soname.patch
Patch3:		%{name}-dynlink.patch
URL:		http://code.google.com/p/v8/
BuildRequires:	libstdc++-devel >= 5:4.0
BuildRequires:	python >= 1:2.4
BuildRequires:	readline-devel
BuildRequires:	scons >= 1.0.0
BuildRequires:	sed >= 4.0
Requires:	%{name}-libs = %{version}-%{release}
ExclusiveArch:	%{ix86} %{x8664} arm
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		sover	%(echo %{version} | cut -d. -f1-2)

%description
V8 is Google's open source JavaScript engine. V8 is written in C++ and
is used in Google Chrome, the open source browser from Google. V8
implements ECMAScript as specified in ECMA-262, 3rd edition.

This package contains the V8 developer shell.

%description -l pl.UTF-8
V8 to mający otwarte źródła silnik JavaScriptu firmy Google. V8 jest
napisany w C++ i wykorzystywany w mającej otwarte źródła przeglądarce
Google Chrome. V8 implementuje ECMAScript zgodnie ze specyfikacją
ECMA-262, edycja 3.

Ten pakiet zawiera powłokę programistyczną V8.

%package libs
Summary:	V8 JavaScript Engine shared library
Summary(pl.UTF-8):	Biblioteka współdzielona silnika JavaScriptu V8
Group:		Libraries
Conflicts:	v8 < 2.0.0

%description libs
V8 is Google's open source JavaScript engine. V8 is written in C++ and
is used in Google Chrome, the open source browser from Google. V8
implements ECMAScript as specified in ECMA-262, 3rd edition.

This package contains the shared library.

%description libs -l pl.UTF-8
V8 to mający otwarte źródła silnik JavaScriptu firmy Google. V8 jest
napisany w C++ i wykorzystywany w mającej otwarte źródła przeglądarce
Google Chrome. V8 implementuje ECMAScript zgodnie ze specyfikacją
ECMA-262, edycja 3.

Ten pakiet zawiera bibliotekę współdzieloną.

%package devel
Summary:	Development headers for V8 JavaScript engine
Summary(pl.UTF-8):	Pliki nagłówkowe silnika JavaScriptu V8
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	libstdc++-devel

%description devel
Development headers for V8 JavaScript engine.

%description devel -l pl.UTF-8
Pliki nagłówkowe silnika JavaScriptu V8.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%{__sed} -i -e "s,'-O3','%{rpmcxxflags}'.split(' ')," SConstruct
# some "unused-but-set" warnings
%{__sed} -i -e "s/'-Werror',//" SConstruct

%build
# build library
CFLAGS="%{rpmcflags}"
CXXFLAGS="%{rpmcxxflags}"
LDFLAGS="%{rpmldflags}"
%if "%{pld_release}" == "ac"
CC="%{__cc}4"
CXX="%{__cxx}4"
%else
CC="%{__cc}"
CXX="%{__cxx}"
%endif
export CFLAGS LDFLAGS CXXFLAGS CC CXX
%scons library d8 \
	library=shared \
	snapshots=on \
	soname=on \
	console=readline \
	visibility=default \
%ifarch %{x8664}
	arch=x64 \
%endif
	env=CCFLAGS:"-fPIC"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_includedir},%{_libdir}}

for lib in libv8 libv8preparser; do
	install -p $lib.so $RPM_BUILD_ROOT%{_libdir}/$lib.so.%{version}
	ln -sf $lib.so.%{version} $RPM_BUILD_ROOT%{_libdir}/$lib.so.%{sover}
	ln -sf $lib.so.%{version} $RPM_BUILD_ROOT%{_libdir}/$lib.so
done
cp -p include/*.h $RPM_BUILD_ROOT%{_includedir}

install -p d8 $RPM_BUILD_ROOT%{_bindir}

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog LICENSE LICENSE.strongtalk LICENSE.valgrind
%attr(755,root,root) %{_bindir}/d8

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libv8.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libv8.so.%{sover}
%attr(755,root,root) %{_libdir}/libv8preparser.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libv8preparser.so.%{sover}

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libv8.so
%attr(755,root,root) %{_libdir}/libv8preparser.so
%{_includedir}/v8*.h

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: v8.spec,v $
Revision 1.32  2012/01/05 13:45:43  glen
- up to 3.6.6.15

Revision 1.31  2011/11/17 21:06:09  glen
- up to 3.6.6.8

Revision 1.30  2011/11/15 12:28:37  glen
- increase soversion to 3.6, as v6 3.4 is not abi compatible with 3.6

Revision 1.29  2011/11/15 06:19:37  glen
- i don't see reason why rename d8 binary; readline todo

Revision 1.28  2011/11/14 11:23:56  glen
- fix soname for libv8preparser library

Revision 1.27  2011/11/14 10:58:30  glen
- strict deps

Revision 1.26  2011/11/14 06:31:34  glen
- up to 3.6.6.7, used by chromium-browser-16.0.912.36

Revision 1.25  2011/06/14 18:44:04  qboosh
- use dropin for Source0

Revision 1.24  2011/06/14 18:40:35  qboosh
- updated to 3.4.3
- fixed dynlink patch (do not replace all needed libs by just libv8)
- one more fix in strndup patch (this patch replaces old 2.0.0-d8-allocation patch)
- general spec cleanup
- pl

Revision 1.23  2011/05/16 07:41:26  aredridel
- 3.3.6.1
- patch SConstruct to build properly instead of the hackery that needed a
  list of modules edited each time
- TODO: fix readline

Revision 1.22  2011/03/22 09:10:50  caleb
- Up to 3.2.0.1

Revision 1.21  2011/03/05 09:27:49  glen
- fix soname

Revision 1.20  2011/03/05 09:19:10  glen
- 3.1.6.1, use gentoo tarballs
- quote CC/CXX
- simplify macros

Revision 1.19  2011/03/05 08:58:26  glen
- remove orphaned patch
- fix gcc deps
- cleanups

Revision 1.18  2011/02/19 07:49:55  aredridel
- up to 3.1.5.0

Revision 1.17  2010/07/28 00:09:03  aredridel
- 2.3.3.1

Revision 1.16  2010/07/03 23:27:19  aredridel
- 2.2.21

Revision 1.15  2010/06/12 00:28:54  aredridel
- 2.2.16.0

Revision 1.14  2010/05/30 19:57:41  aredridel
- 2.2.12

Revision 1.13  2010/05/07 06:30:23  aredridel
- 2.2.8.0

Revision 1.12  2010/04/30 06:20:38  aredridel
- 20100429

Revision 1.11  2010/04/24 03:18:33  aredridel
- 2.2.4.2

Revision 1.10  2010/03/29 05:07:36  aredridel
- up to r4300

Revision 1.9  2010/03/10 04:24:54  aredridel
- version is 2.1.2.6 (hard to tell because of how the release process works)

Revision 1.8  2010/03/10 04:22:44  aredridel
- up to r4070 / 2.0.6+
- fix minor type mismatch
- patch for older libstdc++ lack of cstdio
- build on Ac with GCC4

Revision 1.7  2009/12/02 07:12:43  glen
- libs split; rel 1

Revision 1.6  2009/12/02 07:08:04  glen
- up to 2.0.0 (20091118svn3334)

Revision 1.5  2009/11/15 00:33:09  zbyniu
- BR: libstdc++-devel

Revision 1.4  2009/09/20 10:01:38  glen
- build with our cflags, builds now in carme-i686

Revision 1.3  2009/09/19 10:48:19  glen
- optflags todo

Revision 1.2  2009/09/19 10:35:01  glen
- unify

Revision 1.1  2009/09/18 19:04:21  arekm
- google v8 javascript engine
